comment*=======================================================
          Example of using Scintilla Source editing component
             as a static library in masm32 by Shaka_Zulu
        =======================================================
*
	.586
	.model flat,stdcall
	option casemap:none
	
		include windows.inc
		include kernel32.inc
		include user32.inc
		include gdi32.inc
		include comdlg32.inc
		
		include Scintilla.inc
		includelib Scintilla.lib

		includelib kernel32.lib
		includelib user32.lib
		includelib gdi32.lib
		includelib comdlg32.lib
		
		
		FileOpen PROTO :DWORD
		FileSaveAs PROTO :DWORD
		SetupLanguage PROTO :DWORD
		ShellRunProc PROTO :DWORD
		
		
		IDM_EXIT equ 101
		IDM_OPEN equ 102
		IDM_NEW  equ 103
		IDM_SAVEAS equ 104
		IDM_LINENUMBERS equ 105
		IDM_SAVE equ 106
		IDM_WORDWRAP equ 107
		IDM_INDENTGUIDE equ 111
		IDM_RUN equ 112
		
		.data?
		hInstance HINSTANCE ?
		hMenu HWND ?
		pMappedFile DWORD ?
		hDocumentBuffer LPSTR ?
		szFileName db 260 dup(?)
		
		.data
		ClassName db "Window_Class",0
		DspName db "xpad",0
		ScintillaClass db "Scintilla",0
		fontname db "Courier New",0
		digit db "9",0
		
		
		filter db "All files (*.*)",0
		 db "*.*",0
		 SciFunction SCIFUNCTIONPOINTER 0
		 hSci HWND 0
		 hDirectPointer DWORD 0
		 lines_visible BOOL FALSE
		 wrap_active BOOL FALSE
		 indent_visible BOOL FALSE
		 lexername db "asm",0
		 
		 include Syntax_Highlighting.asm
		 
.code	

ProgramStartUp PROC 
		
		LOCAL wc :WNDCLASSEX
		LOCAL msg :MSG
		LOCAL hwnd :HWND
		
            invoke GetModuleHandle,NULL
            mov hInstance,eax
            
			mov wc.cbClsExtra,NULL
			mov wc.cbSize,sizeof WNDCLASSEX
			mov wc.cbWndExtra,NULL
			invoke GetStockObject,NULL_BRUSH
			mov wc.hbrBackground,eax ;//to provide a nonflickering surface
			invoke LoadCursor,0,IDC_ARROW
			mov wc.hCursor,eax
			invoke LoadIcon,hInstance,IDI_APPLICATION
			mov wc.hIcon,eax
			mov wc.hIconSm,eax
			push hInstance
			pop wc.hInstance
			mov wc.lpfnWndProc,OFFSET WndProc
			mov wc.lpszClassName,OFFSET ClassName
			mov wc.lpszMenuName,NULL
			mov wc.style,0
			
			invoke RegisterClassEx,ADDR wc
			invoke CreateWindowEx,0,ADDR ClassName,ADDR DspName,WS_OVERLAPPEDWINDOW,300,150,550,500,0,0,hInstance,0
			mov hwnd,eax
			invoke ShowWindow,hwnd,SW_SHOWNORMAL
			invoke UpdateWindow,hwnd
			.while TRUE 
				invoke GetMessage,ADDR msg,0,0,0
				.break .if(!eax)
				invoke TranslateMessage,ADDR msg
				invoke DispatchMessage,ADDR msg
			.endw
		mov eax,msg.wParam
	ret
ProgramStartUp ENDP

WndProc PROC hwnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
	
	LOCAL rc :RECT
		
		.if uMsg == WM_CREATE
			invoke LoadMenu,hInstance,100
			mov hMenu,eax
			invoke SetMenu,hwnd,hMenu
			;//initializing the Scintilla (registering class)
			invoke Sci_Init,hInstance
			invoke CheckLexers
			invoke GetClientRect,hwnd,addr rc
			invoke CreateWindowEx,WS_EX_CLIENTEDGE,addr ScintillaClass,NULL,WS_CHILD or WS_VISIBLE,rc.left,rc.top,rc.right,rc.bottom,hwnd,0,hInstance,0
			mov hSci,eax
			invoke SendMessage,hSci,SCI_GETDIRECTFUNCTION,0,0
			mov SciFunction,eax
			invoke SendMessage,hSci,SCI_GETDIRECTPOINTER,0,0
			mov hDirectPointer,eax
			
			;//changing the font:
			invoke SciFunction,hDirectPointer, SCI_STYLESETFONT, STYLE_DEFAULT, addr fontname
			invoke SciFunction,hDirectPointer,SCI_STYLESETBOLD,STYLE_DEFAULT,TRUE
			invoke SciFunction,hDirectPointer,SCI_SETMARGINWIDTHN,1,0
			invoke SetupLanguage,NULL
			invoke SetFocus,hSci
			
		.elseif uMsg == WM_SIZE
			invoke GetClientRect,hwnd,addr rc
			invoke MoveWindow,hSci,rc.left,rc.top,rc.right,rc.bottom,1
		
		.elseif uMsg == WM_CLOSE
			invoke ExitProcess,0
			
		.elseif uMsg == WM_COMMAND
			.if wParam == IDM_EXIT
				invoke UnregisterClass,addr ScintillaClass,hInstance
				invoke PostQuitMessage,NULL
				ret
				
			.elseif wParam == IDM_OPEN
			
				invoke FileOpen,hwnd
				invoke SetFocus,hSci
			
			.elseif wParam == IDM_NEW
				invoke SciFunction,hDirectPointer,SCI_CLEARALL,0,0
				mov szFileName,NULL
				.if lines_visible
					call UpdateViewOfLineNumbers
				.endif
			.elseif wParam == IDM_SAVEAS	
				
				invoke FileSaveAs,hwnd
				
			.elseif wParam == IDM_LINENUMBERS
				.if !lines_visible
					mov lines_visible,TRUE
					invoke CheckMenuItem,hMenu,IDM_LINENUMBERS,MF_CHECKED
					call UpdateViewOfLineNumbers
				.else
					mov lines_visible,FALSE
					invoke CheckMenuItem,hMenu,IDM_LINENUMBERS,MF_UNCHECKED
					call UpdateViewOfLineNumbers
				.endif
				
			.elseif wParam == IDM_WORDWRAP
				.if !wrap_active
					mov wrap_active,TRUE
					invoke CheckMenuItem,hMenu,IDM_WORDWRAP,MF_CHECKED
					invoke SciFunction,hDirectPointer,SCI_SETWRAPMODE,1,0
				.else
					mov wrap_active,FALSE
					invoke CheckMenuItem,hMenu,IDM_WORDWRAP,MF_UNCHECKED
					invoke SciFunction,hDirectPointer,SCI_SETWRAPMODE,0,0
				.endif
			
			.elseif wParam == IDM_INDENTGUIDE
				.if !indent_visible
					mov indent_visible,TRUE
					invoke SciFunction,hDirectPointer,SCI_SETINDENTATIONGUIDES,TRUE,0
					invoke CheckMenuItem,hMenu,IDM_INDENTGUIDE,MF_CHECKED
				.else
					mov indent_visible,FALSE
					invoke SciFunction,hDirectPointer,SCI_SETINDENTATIONGUIDES,FALSE,0
					invoke CheckMenuItem,hMenu,IDM_INDENTGUIDE,MF_UNCHECKED
				.endif	
				
			.elseif wParam == IDM_SAVE
				call FileSave
				
			.elseif wParam == IDM_RUN
				invoke ShellRunProc,hwnd
					
			.endif
		
		.elseif uMsg == WM_NOTIFY
			mov ebx,lParam
			mov eax,NMHDR.hwndFrom[ebx]
			.if eax == hSci
				.if SCNOTIFICATION.linesAdded[ebx]
					.if lines_visible
						call UpdateViewOfLineNumbers
					.endif
				.endif
			.endif
		
		.endif
		
		invoke DefWindowProc,hwnd,uMsg,wParam,lParam
	ret
WndProc ENDP

FileOpen PROC hParent:DWORD
		
		LOCAL ofn :OPENFILENAME
		LOCAL hFile :DWORD
		LOCAL hMap	:DWORD
		LOCAL fSize :DWORD
		
			invoke  RtlZeroMemory,addr ofn,sizeof OPENFILENAME
			mov szFileName,NULL
				
			mov ofn.lStructSize,sizeof OPENFILENAME
			push hParent
			pop ofn.hwndOwner
			mov ofn.lpstrFilter,offset filter
			push offset szFileName
			pop ofn.lpstrFile
			mov ofn.nMaxFile,MAX_PATH
			mov ofn.lpstrDefExt,NULL
			mov ofn.Flags,OFN_EXPLORER or OFN_FILEMUSTEXIST
			push hInstance
			pop ofn.hInstance
			
			invoke GetOpenFileName,addr ofn
			.if !eax
				xor eax,eax
				ret
			.endif
			invoke CreateFile,addr szFileName,GENERIC_READ,FILE_SHARE_READ,0,
				OPEN_EXISTING,0,0
			mov hFile,eax
			
			.if eax != INVALID_HANDLE_VALUE
				invoke GetFileSize,hFile,NULL
				mov fSize,eax
				invoke CreateFileMapping,hFile,NULL,PAGE_READONLY,0,0,NULL
				mov hMap,eax
				invoke MapViewOfFile,hMap,FILE_MAP_READ,0,0,0
				mov pMappedFile,eax
			.endif
			
			invoke GetFileSize,hFile,NULL
			invoke SciFunction,hDirectPointer,SCI_ALLOCATE,eax,NULL
			mov hDocumentBuffer,eax
			
			
			invoke CloseHandle,hFile
			invoke SciFunction,hDirectPointer,SCI_SETTEXT,0,pMappedFile
			invoke UnmapViewOfFile,pMappedFile
			
xor eax,eax		
ret
FileOpen ENDP

FileSaveAs PROC hParent:DWORD
		LOCAL ofn :OPENFILENAME
		LOCAL hFile :DWORD
		LOCAL lpBuffer	:DWORD
		LOCAL fSize :DWORD
		LOCAL written :DWORD
		
			invoke  RtlZeroMemory,addr ofn,sizeof OPENFILENAME
			mov ofn.lStructSize,sizeof OPENFILENAME
			push hParent
			pop ofn.hwndOwner
			mov ofn.lpstrFilter,offset filter
			push offset szFileName
			pop ofn.lpstrFile
			mov ofn.nMaxFile,MAX_PATH
			mov ofn.lpstrDefExt,NULL
			mov ofn.Flags,OFN_EXPLORER or OFN_FILEMUSTEXIST
			push hInstance
			pop ofn.hInstance
			
			invoke GetSaveFileName,addr ofn
			.if !eax
				xor eax,eax
				ret
			.endif
			
			invoke SciFunction,hDirectPointer,SCI_GETTEXTLENGTH,0,0
			mov fSize,eax
			invoke lstrcpy,addr szFileName,ofn.lpstrFile
			invoke GlobalAlloc,GPTR,fSize
			mov lpBuffer,eax
			
			mov eax,fSize
			add eax,1
			invoke SciFunction,hDirectPointer,SCI_GETTEXT,eax,lpBuffer
			invoke CreateFile,addr szFileName,GENERIC_WRITE,FILE_SHARE_WRITE,0,
				OPEN_ALWAYS,0,0
			mov hFile,eax
			invoke WriteFile,hFile,lpBuffer,fSize,addr written,NULL
			invoke CloseHandle,hFile
			invoke GlobalFree,lpBuffer
			
ret
FileSaveAs ENDP

UpdateViewOfLineNumbers PROC
	
	LOCAL linecount :DWORD
	LOCAL lineNumWidth	
	
		;//the width will be calculated ,depending of how many digits is the count of lines	
		.if !lines_visible
			invoke SciFunction,hDirectPointer,SCI_SETMARGINWIDTHN,0,0
			xor eax,eax
			ret
		.endif
		
		mov lineNumWidth,5
		invoke SciFunction,hDirectPointer,SCI_GETLINECOUNT,0,0
		mov linecount,eax
		.if linecount >= 100
			.while linecount >= 10
				mov eax,linecount
				cdq
				mov ecx,10
				idiv ecx
				mov linecount,eax
				add lineNumWidth,10
			.endw
			invoke SciFunction,hDirectPointer,SCI_SETMARGINWIDTHN,0,lineNumWidth
		.else
			invoke SciFunction,hDirectPointer,SCI_SETMARGINWIDTHN,0,20
		.endif

mov eax,TRUE		
ret
UpdateViewOfLineNumbers ENDP

FileSave PROC
	
	LOCAL written :DWORD
	LOCAL txtsize :DWORD
	LOCAL lpBuffer :DWORD
	LOCAL hFile :DWORD
	
		invoke SciFunction,hDirectPointer,SCI_GETTEXTLENGTH,0,0
		mov txtsize,eax
		invoke GlobalAlloc,GPTR,txtsize
		mov lpBuffer,eax
		mov eax,txtsize
		add eax,1
		invoke SciFunction,hDirectPointer,SCI_GETTEXT,eax,lpBuffer
		invoke CreateFile,addr szFileName,GENERIC_WRITE,FILE_SHARE_WRITE,0,
				OPEN_ALWAYS,0,0
		mov hFile,eax
		invoke WriteFile,hFile,lpBuffer,txtsize,addr written,NULL
		invoke CloseHandle,hFile
		invoke GlobalFree,lpBuffer

ret
FileSave ENDP


SetupLanguage PROC reserved1:DWORD
	
	invoke SciFunction,hDirectPointer,SCI_SETKEYWORDS,0,addr CPU_Instructions
	invoke SciFunction,hDirectPointer,SCI_SETKEYWORDS,1,addr math_instructions
	invoke SciFunction,hDirectPointer,SCI_SETKEYWORDS,2,addr registers
	invoke SciFunction,hDirectPointer,SCI_SETKEYWORDS,3,addr directive
	invoke SciFunction,hDirectPointer,SCI_SETKEYWORDS,4,addr directive_operand
	invoke SciFunction,hDirectPointer,SCI_SETKEYWORDS,5,addr extended_instructions
	
	
	invoke SciFunction,hDirectPointer,SCI_STYLESETFORE,SCE_ASM_CPUINSTRUCTION,1624A0h
	invoke SciFunction,hDirectPointer,SCI_STYLESETFORE,SCE_ASM_MATHINSTRUCTION,0D96C00h
	invoke SciFunction,hDirectPointer,SCI_STYLESETFORE,SCE_ASM_REGISTER,0A8A800h
	invoke SciFunction,hDirectPointer,SCI_STYLESETFORE,SCE_ASM_DIRECTIVE,0CD2214h
	invoke SciFunction,hDirectPointer,SCI_STYLESETFORE,SCE_ASM_DIRECTIVEOPERAND,171070h
	invoke SciFunction,hDirectPointer,SCI_STYLESETFORE,SCE_ASM_EXTINSTRUCTION,70DFh
	
	invoke SciFunction,hDirectPointer,SCI_STYLESETFORE,SCE_ASM_NUMBER,118BAh
	invoke SciFunction,hDirectPointer,SCI_STYLESETFORE,SCE_ASM_COMMENT,8A00h
	invoke SciFunction,hDirectPointer,SCI_STYLESETFORE,SCE_ASM_STRING,0A7A7A7h
	
	
	invoke SciFunction,hDirectPointer,SCI_SETLEXER,SCLEX_ASM,0
	
xor eax,eax
ret
SetupLanguage ENDP

ShellRunProc PROC hwnd:DWORD

		
		LOCAL SHRunDialog:DWORD
		
			jmp @F
			.const 
			shrdNoMRUString equ 2
			.data
			ShelloduleName db "Shell32.dll",0
			.code
			@@:
			invoke GetModuleHandle,addr ShelloduleName
			invoke GetProcAddress,eax,61
			mov SHRunDialog,eax
			push shrdNoMRUString
			push 0
			push 0
			push 0
			push 0
			push hwnd
			call SHRunDialog
			
ret
ShellRunProc ENDP

END



